/*=============================================================================
	FerBotzNative.cpp
	You are permitted to use and distribute this code
	Higor:
	Just saying, if you make something out of this let me know.
	I'd love to see what comes out of this
	caco_fff@hotmail.com
=============================================================================*/

// Includes.
#include "Ferbotz.h"

/*-----------------------------------------------------------------------------
	The following must be done once per package (.dll).
-----------------------------------------------------------------------------*/

// This is some necessary C++/UnrealScript glue logic.
// If you forget this, you get a VC++ linker errors like:
// SampleClass.obj : error LNK2001: unresolved external symbol "class FName  SAMPLENATIVEPACKAGE_SampleEvent" (?SAMPLENATIVEPACKAGE_SampleEvent@@3VFName@@A)
#define NAMES_ONLY
#define AUTOGENERATE_NAME(name) FERBOTZ_API FName FERBOTZ_##name;
#define AUTOGENERATE_FUNCTION(cls,idx,name) IMPLEMENT_FUNCTION(cls,idx,name)
#include "FerBotzClasses.h"
#undef AUTOGENERATE_FUNCTION
#undef AUTOGENERATE_NAME
#undef NAMES_ONLY
void RegisterNames()
{
	static INT Registered=0;
	if(!Registered++)
	{
		#define NAMES_ONLY
		#define AUTOGENERATE_NAME(name) extern FERBOTZ_API FName FERBOTZ_##name; FERBOTZ_##name=FName(TEXT(#name),FNAME_Intrinsic);
		#define AUTOGENERATE_FUNCTION(cls,idx,name)
		#include "FerBotzClasses.h"
		#undef DECLARE_NAME
		#undef NAMES_ONLY
	}
}

// Package implementation.
IMPLEMENT_PACKAGE(Ferbotz);

/*-----------------------------------------------------------------------------
	ABotz functions
-----------------------------------------------------------------------------*/

void ABotz::execThisOrThat(FFrame &Stack, RESULT_DECL)
{
	P_GET_ACTOR(A);
	P_GET_ACTOR(B);
	P_GET_ACTOR_OPTX(C,NULL);
	P_GET_ACTOR_OPTX(D,NULL);
	P_FINISH;

//	*(AActor**)Result = FirstNonNull(A,B,C,D);
	AActor *F;

	if ( A != NULL )
		F = A;
	else if ( B != NULL )
		F = B;
	else if ( C != NULL )
		F = C;
	else
		F = D;

	*(AActor**)Result = F;
}


// ITERATORS HERE
#include "ABotz_Iterators.h"

/*-----------------------------------------------------------------------------
	ABotz_NavigBase functions
-----------------------------------------------------------------------------*/

//Limitation: doesn't set bStatic to true
void ABotz_NavigBase::execLockActor(FFrame &Stack, RESULT_DECL)
{
#ifndef __LINUX_X86__
	guard(ABotz_NavigBase::execLockActor);
#endif
	P_GET_UBOOL(bLock);
	P_GET_NAVIG_OPTX( nBase, this);
	P_FINISH;

	if ( (nBase->bStatic | nBase->bNoDelete) != bLock )
	{
		nBase->bNoDelete = bLock;
		if ( bLock )
		{
			nBase->nextNavigationPoint = Level->NavigationPointList;
			Level->NavigationPointList = nBase;
		}
		else
		{
			nBase->bStatic = false;
			if ( Level->NavigationPointList == nBase )
			{
				Level->NavigationPointList = nBase->nextNavigationPoint;
				nBase->nextNavigationPoint = NULL;
			}
			else
			{
				ANavigationPoint *N = Level->NavigationPointList;
				while ( N )
				{
					if ( N->nextNavigationPoint == nBase )
					{
						N->nextNavigationPoint = nBase->nextNavigationPoint;
						nBase->nextNavigationPoint = NULL;
						N = NULL;
					}
					else
						N = N->nextNavigationPoint;
				}
			}
		}
	}

#ifndef __LINUX_X86__
	unguard;
#endif
}

inline INT FindExistingDest( ANavigationPoint *Org, AActor *A)
{
	for ( INT i=0 ; (i<16 && Org->Paths[i] >= 0) ; i++ )
		if ( Org->XLevel->ReachSpecs( Org->Paths[i] ).End == A )
			return Org->Paths[i];
	return -1;
}

inline INT FindPrunedDest( ANavigationPoint *Org, AActor *A)
{
	for ( INT i=0 ; (i<16 && Org->PrunedPaths[i] >= 0) ; i++ )
		if ( Org->XLevel->ReachSpecs( Org->PrunedPaths[i] ).End == A )
			return Org->PrunedPaths[i];
	return -1;
}


//Does not check pruned paths
void ABotz_NavigBase::execExistingPath(FFrame &Stack, RESULT_DECL)
{
#ifndef __LINUX_X86__
	guard(ABotz_NavigBase::execExistingPath);
#endif
	P_GET_ACTOR(A);
	P_FINISH;

	*(INT*)Result = FindExistingDest( this, A);
#ifndef __LINUX_X86__
	unguard;
#endif
}

void ABotz_NavigBase::execUnusedReachSpec(FFrame &Stack, RESULT_DECL)
{
	P_FINISH;

	INT B = -1;
	for ( INT i = 0; i<XLevel->ReachSpecs.Num() ; i++ )
	{
		FReachSpec *RS;
		RS = &XLevel->ReachSpecs(i);
		if ( RS->Start == NULL && RS->End == NULL )
		{
			B = i;
			break;
		}
	}
	*(INT*)Result = B;
}

void ABotz_NavigBase::execEditReachSpec(FFrame &Stack, RESULT_DECL)
{
#ifndef __LINUX_X86__
	guard(ABotz_NavigBase::execEditReachSpec);
#endif
	P_GET_INT(i);
	P_GET_ACTOR(A);
	P_GET_ACTOR(B);
	P_GET_FLOAT_OPTX(C, 60);
	P_GET_FLOAT_OPTX(D, 40);
	P_GET_UBOOL_OPTX(bTele, false);
	P_FINISH;

/* Reach flags description:
1 = Walking required.
2 = Flying required.
4 = Swimming required.
8 = Jumping required.
16 = Door way.
32 = Special path (teleporter, LiftCenter/Exit).
64 = Players only path. */

	if ( i >= 0 && i < XLevel->ReachSpecs.Num() )
	{
		INT ReachFlags = 0;
		if ( A && B )
		{
			if ( A->Region.Zone->bWaterZone || B->Region.Zone->bWaterZone )
				ReachFlags = ReachFlags | 4;
			if ( A->IsA( ABotz_NavigBase::StaticClass()) )
			{
				if ( ((ABotz_NavigBase*)A)->bFlying )
					ReachFlags = ReachFlags | 2;
				if ( ((ABotz_NavigBase*)A)->bCustomFlags )
					ReachFlags = eventModifyFlags( (ANavigationPoint*)B, ReachFlags);
			}
			if ( B->IsA( ABotz_NavigBase::StaticClass()) )
			{
				if ( ((ABotz_NavigBase*)B)->bFlying )
					ReachFlags = ReachFlags | 2;
				if ( ((ABotz_NavigBase*)B)->bCustomFlags )
					ReachFlags = eventModifyFlags( (ANavigationPoint*)A, ReachFlags);
			}
		}

		FReachSpec *RS;
		RS = &XLevel->ReachSpecs(i);
		RS->Start = A;
		RS->End = B;
		RS->CollisionHeight = (INT) C;
		RS->CollisionRadius = (INT) D;
		RS->reachFlags = ReachFlags;
		RS->bPruned = 0;
		if ( !bTele && A && B )
			RS->distance = (INT) FVector(A->Location - B->Location).Size();
		else if ( !bTele )
			RS->bPruned = 1;
		else
			RS->distance = 0;
		
		*(UBOOL*)Result = true;
	}
	else
		*(UBOOL*)Result = false;

#ifndef __LINUX_X86__
	unguard;
#endif
}

void ABotz_NavigBase::execIsConnectedTo(FFrame &Stack, RESULT_DECL)
{
#ifndef __LINUX_X86__
	guard(ABotz_NavigBase::execIsConnectedTo);
#endif
	P_GET_NAVIG(A);
	P_GET_NAVIG(B);
	P_GET_UBOOL_OPTX( pruned, false);
	P_FINISH;

	INT found = -1;
	if ( A && B )
	{
		found = FindExistingDest( A, B);
		if ( pruned && found < 0 )
			found = FindPrunedDest( A, B);
	}
	*(INT*)Result = found;
#ifndef __LINUX_X86__
	unguard;
#endif
}

void ABotz_NavigBase::execConnectedDests(FFrame &Stack, RESULT_DECL)
{
#ifndef __LINUX_X86__
	guard(ABotz_NavigBase::execConnectedDests);
#endif
	P_GET_NAVIG_OPTX(Start,this); //Careful with this
	P_GET_ACTOR_REF(End);
	P_GET_INT_REF(Idx);
	P_FINISH;

	INT i = 0;

	PRE_ITERATOR;
		*End = NULL;
		*Idx = -1;
		if ( !Start ) //Get out of this iterator if no start point
		{
			Stack.Code = &Stack.Node->Script(wEndOffset + 1);
			break;
		}

		while ( i<16 && Start->Paths[i] < 0 ) //Skip invalid paths
			i++;

		if ( i<16 )
		{
			FReachSpec *RS;
			RS = &XLevel->ReachSpecs(Start->Paths[i]);
			*End = RS->End;
			*Idx = Start->Paths[i];
			i++;
		}
		else
		{
			Stack.Code = &Stack.Node->Script(wEndOffset + 1);
			break;
		}
	POST_ITERATOR;
#ifndef __LINUX_X86__
	unguard;
#endif
}

void ABotz_NavigBase::execCreateReachSpec(FFrame &Stack, RESULT_DECL)
{
#ifndef __LINUX_X86__
	guard(ABotz_NavigBase::execCreateReachSpec);
#endif
	P_FINISH;

	INT i = XLevel->ReachSpecs.Num();
	XLevel->ReachSpecs.Add(1);
	*(INT*)Result = i;

#ifndef __LINUX_X86__
	unguard;
#endif
}


inline INT CanTakeIncomingPath( ABotz_NavigBase *aEnd, ANavigationPoint *aStart)
{
//	return 1; //WHY IS THIS HAPPENING?
	//Incoming checks
	if ( aEnd->bOneWayInc )
	{
		FVector dir = aStart->Location - aEnd->Location;
		if ( dir.Normalize() == 0 ) //Vectors nearly equal
			return 0;
		return FVector(dir + aEnd->Rotation.Vector() ).SizeSquared() >= 2;
	}
	return 1;
}

inline INT CanSendOutgoingPath( ABotz_NavigBase *aStart, ANavigationPoint *aEnd)
{
	if ( aStart->bOneWayOut )
	{
		FVector dir = aEnd->Location + aStart->Location;
		if ( dir.Normalize() == 0 ) //Vectors nearly equal
			return 0;
		return FVector(dir + aStart->Rotation.Vector() ).SizeSquared() >= 2;
	}
	return 1;
}

inline INT _FreeSlot( int *Elem)
{
	for ( int i=0 ; i<16 ; i++ )
		if ( *(Elem+i) == -1 )
			return i;
	return -1;
}

inline INT _CountFreeSlots( int *Elem)
{
	INT j = 0;
	for ( int i=0 ; i<16 ; i++ )
		if ( *(Elem+i) == -1 )
			j++;
	return j;
}

void ABotz_NavigBase::execFreePathSlot(FFrame &Stack, RESULT_DECL)
{
	P_GET_NAVIG(N);
	P_FINISH;
		*(INT*)Result = _FreeSlot( &(N->Paths[0]) );
}
void ABotz_NavigBase::execFreeUpstreamSlot(FFrame &Stack, RESULT_DECL)
{
	P_GET_NAVIG(N);
	P_FINISH;
		*(INT*)Result = _FreeSlot( &(N->upstreamPaths[0]) );
}

inline void _CleanReachSpec( FReachSpec *RS)
{
	RS->Start = NULL;
	RS->End = NULL;
	RS->bPruned = 1;
	RS->reachFlags = 0;
}

void ABotz_NavigBase::execClearAllPaths(FFrame &Stack, RESULT_DECL)
{
//	guard(ABotz_NavigBase::execClearAllPaths);
	P_GET_NAVIG(N);
	P_FINISH;

	if ( N == NULL )
		return;

	//Process Paths[i]
	for ( int i=0 ; i<16 ; i++ )
	{
		if ( N->Paths[i] != -1 )
		{
			ANavigationPoint* Dest = (ANavigationPoint*)N->XLevel->ReachSpecs( N->Paths[i] ).End;
			_CleanReachSpec( &N->XLevel->ReachSpecs( N->Paths[i]) );
			if ( Dest )
			{
				bool bFound = false;
				for ( int j=0 ; j<15 ; j++ )
				{
					if ( !bFound && (Dest->upstreamPaths[j] == N->Paths[i]) )
						bFound = true;
					if ( bFound )
						Dest->upstreamPaths[j] = Dest->upstreamPaths[j+1];
				}
				Dest->upstreamPaths[15] = -1;
			}
		}

		if ( N->upstreamPaths[i] != -1 )
		{
			ANavigationPoint* Start = (ANavigationPoint*)N->XLevel->ReachSpecs( N->upstreamPaths[i] ).Start;
			if ( Start )
			{
				bool bFound = false;
				for ( int j=0 ; j<15 ; j++ )
				{
					if ( !bFound && (Start->Paths[j] == N->upstreamPaths[i]) )
						bFound = true;
					if ( bFound )
						Start->Paths[j] = Start->Paths[j+1];
				}
				Start->Paths[15] = -1;
			}
		}
		N->Paths[i] = -1;
		N->upstreamPaths[i] = -1;
	}

//	unguard;
}


void ABotz_NavigBase::execPathCandidates(FFrame &Stack, RESULT_DECL)
{
	RegisterNames();

#ifndef __LINUX_X86__
	guard(ABotz_NavigBase::execPathCandidates);
#endif
	P_FINISH;

	ANavigationPoint *N = Level->NavigationPointList;
	FLOAT dist = MaxDistance * MaxDistance;
	ABotz_NavigBase *B;
	UClass *BaseClass = ABotz_NavigBase::StaticClass();

	if ( N == this )
		N = N->nextNavigationPoint;

	while ( N )
	{
		if ( (FVector(Location - N->Location).SizeSquared() <= dist) && (FindExistingDest(this, N) < 0) && (FindPrunedDest(this, N) < 0) )
		{
			BYTE pathType = 0;
			if ( N->IsA( BaseClass) ) //Logic for NavigBase <> NavigBase
			{
				B = (ABotz_NavigBase*)N;
				if ( CanTakeIncomingPath( B, this) && CanSendOutgoingPath(this, N) ) //This path will check back in it's own PathCandidates function, safe to deny here
				{
					pathType = B->eventIsCandidateTo( this);
					if ( pathType == PM_Normal )
						pathType = eventOtherIsCandidate( N);
				}
			}
			else //Logic for NavigBase <> NavigationPoint
			{
				B = NULL;
				if ( CanSendOutgoingPath(this, N) )
					pathType = eventOtherIsCandidate( N);
			}

			if ( pathType )
			{
				if (_CountFreeSlots( &Paths[0] ) > ReservePaths )
					eventAddPathHere( this, N, pathType == PM_Forced );
				if ( B == NULL && (_CountFreeSlots( &upstreamPaths[0] ) > ReserveUpstreamPaths) && (FindExistingDest(N, this) < 0)/* && (FindPrunedDest(N,this) < 0) */) //We just make sure we didn't apply a 2 way path here
					eventAddPathHere( N, this, pathType == PM_Forced ); //Removed conditions... because older Navigbases won't connect with newer ones otherwise
			}
		}

		N = N->nextNavigationPoint;
		if ( N == this )
			N = N->nextNavigationPoint;
	}

	eventFinishedPathing();

#ifndef __LINUX_X86__
	unguard;
#endif
}


/*-----------------------------------------------------------------------------
	ABotz_PathLoader functions
-----------------------------------------------------------------------------*/

void ABotz_PathLoader::Spawned()
{
	Super::Spawned();
#ifdef __LINUX_X86__
	bLinux = 1;
#endif
}

void ABotz_PathLoader::execClearArray(FFrame &Stack, RESULT_DECL)
{
	P_FINISH;
	NavArray.Empty();
}

void ABotz_PathLoader::execAddCurToArray(FFrame &Stack, RESULT_DECL)
{
	P_FINISH;
	
	FNavPoint A = CurNav;
	NavArray.AddItem(A);
}

void ABotz_PathLoader::execArrayToCur(FFrame &Stack, RESULT_DECL)
{
	P_GET_INT(i);
	P_FINISH;

	if ( i >= 0 && i < NavArray.Num() )
	{
		CurNav = NavArray(i);
		*(UBOOL*)Result = true;
	}
	else
		*(UBOOL*)Result = false;

}

void ABotz_PathLoader::execReadArray(FFrame &Stack, RESULT_DECL)
{
	P_GET_STR(SrcFile);
	P_FINISH;

//	TArray<FileList = GFileManager->FindFiles( *path, true, false );

	FArchive* Src = GFileManager->CreateFileReader( *SrcFile );
	if ( Src )
	{
		*Src << NavArray;
		Src->Close();
		delete Src;
		*(UBOOL*)Result = true;
	}
	else
		*(UBOOL*)Result = false;
}

void ABotz_PathLoader::execSaveArray(FFrame &Stack, RESULT_DECL)
{
#ifndef __LINUX_X86__
	guard(ABotz_PathLoader::execSaveArray);
#endif
	P_GET_STR(SrcFile);
	P_FINISH;

	FArchive* Src = GFileManager->CreateFileWriter( *SrcFile, FILEWRITE_EvenIfReadOnly );
	if ( Src )
	{
		*Src << NavArray;
		Src->Close();
		delete Src;
		*(UBOOL*)Result = true;
	}
	else
		*(UBOOL*)Result = false;

#ifndef __LINUX_X86__
	unguard;
#endif
}

//Backwards check is faster because we operate on newer elements
inline bool FoundPruned( ABotz_PathLoader *Loader, FPrunedComp *Navs )
{
	for ( INT i=Loader->Pruned.Num()-1; i>=0 ; i-- )
		if ( Loader->Pruned(i) == *Navs )
			return true;
	return false;
}

void ABotz_PathLoader::execIsPruned(FFrame &Stack, RESULT_DECL)
{
//	guard(ABotz_PathLoader::execIsPruned);
	P_GET_NAVIG(A);
	P_GET_NAVIG(B);
	P_FINISH;

	FPrunedComp C;
	C.Navs[0] = A;
	C.Navs[1] = B;

	*(UBOOL*)Result = FoundPruned( this, &C);
//	unguard;
}

void ABotz_PathLoader::execClearPrunes(FFrame &Stack, RESULT_DECL)
{
	P_FINISH;
	Pruned.Empty();
}

void ABotz_PathLoader::execAddPrune(FFrame &Stack, RESULT_DECL)
{
//	guard(ABotz_PathLoader::execAddPrune);
	P_GET_NAVIG(A);
	P_GET_NAVIG(B);
	P_FINISH;

	FPrunedComp C;
	C.Navs[0] = A;
	C.Navs[1] = B;

	if ( !FoundPruned( this, &C) )
		Pruned.AddItem(C);

//	unguard;
}

void ABotz_PathLoader::execInitPruned(FFrame &Stack, RESULT_DECL)
{
#ifndef __LINUX_X86__
	guard(ABotz_PathLoader::execInitPruned);
#endif
	P_FINISH;

	INT i = XLevel->ReachSpecs.Num() - 1;

	while ( i >= 0 )
	{
		if ( XLevel->ReachSpecs(i).bPruned && XLevel->ReachSpecs(i).Start && XLevel->ReachSpecs(i).End )
		{
			FPrunedComp C;
			C.Navs[0] = (ANavigationPoint*) XLevel->ReachSpecs(i).Start; //Copy pointers, don't even convert to ANavigationPoint
			C.Navs[1] = (ANavigationPoint*) XLevel->ReachSpecs(i).End;
			Pruned.AddItem(C);
			//Experimental:
			_CleanReachSpec( &XLevel->ReachSpecs(i) );
//			XLevel->ReachSpecs(i).Start = NULL;
//			XLevel->ReachSpecs(i).End = NULL;
//			XLevel->ReachSpecs(i).reachFlags = 0;
		}
		i--;
	}

	ANavigationPoint *N = Level->NavigationPointList;
	INT PrunedBlock[16] = { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1};

	while ( N )
	{
		if ( N->PrunedPaths != PrunedBlock )
			appMemcpy( &(N->PrunedPaths), &PrunedBlock, 64); //FAST: Copy the entire array in a single operation
		N = N->nextNavigationPoint;
	}

#ifndef __LINUX_X86__
	unguard;
#endif
}

IMPLEMENT_CLASS(ABotz);
IMPLEMENT_CLASS(ABotz_NavigBase);
IMPLEMENT_CLASS(ABotz_PathLoader);


/*-----------------------------------------------------------------------------
	The End.
-----------------------------------------------------------------------------*/
